/****************************************************
Chip type               : ATmega8
Program type            : Application
AVR Core Clock frequency: 8,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256
*****************************************************/

#include <mega8.h>

#include <delay.h>

// ADC interrupt service routine
// with auto input scanning
interrupt [ADC_INT] void adc_isr(void);

// Analog Comparator interrupt service routine
interrupt [ANA_COMP] void ana_comp_isr(void);

// External Interrupt 0 service routine
interrupt [EXT_INT0] void ext_int0_isr(void);

// External Interrupt 1 service routine
interrupt [EXT_INT1] void ext_int1_isr(void);

// Timer 0 overflow interrupt service routine
interrupt [TIM0_OVF] void timer0_ovf_isr(void);

// Timer1 overflow interrupt service routine
interrupt [TIM1_OVF] void timer1_ovf_isr(void);

// Timer2 overflow interrupt service routine
interrupt [TIM2_OVF] void timer2_ovf_isr(void);

// Declare your global variables here
volatile unsigned int adc_data;
volatile unsigned char dig[11]={192,249,164,176,153,146,130,248,128,144,255},ind[3]={0,0,0},indcnt=0,mode[2]={135,140};
volatile unsigned char vcd=0,tm2c=0,vcd_c=0,vcd_f=0,off=0,ph=0,pl=0,frz=0,frz_tm=0,frz_tm_f=0,ind_tmp=0;
volatile unsigned short t[3]={0,375,69},vcd_tm=0,p=0,t_frz=0,adc_d=0,adc_c=0;
__eeprom unsigned short tmp_m;
__eeprom unsigned char p_m; 

void main(void)
{
// Declare your local variables here

// Input/Output Ports initialization
// Port B initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0 
PORTB=0x00;
DDRB=0xFF;

// Port C initialization
// Func6=In Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=In 
// State6=T State5=0 State4=0 State3=0 State2=0 State1=0 State0=T 
PORTC=0x00;
DDRC=0x3E;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTD=0x00;
DDRD=0x00;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 8,000 000 kHz
TCCR0=0x00;
TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer1 Stopped
// Mode: Normal top=0xFFFF
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: 7,813 kHz
// Mode: Normal top=0xFF
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: On
// INT0 Mode: Rising Edge
// INT1: On
// INT1 Mode: Rising Edge
GICR|=0xC0;
MCUCR=0x0F;
GIFR=0xC0;


// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x45;

// ADC initialization
// ADC Clock frequency: 125,000 kHz
// ADC Voltage Reference: Int., cap. on AREF
ADMUX=0xc0 & 0xff;
ADCSRA=0xCE;

// Analog Comparator initialization
// Analog Comparator: On
// The Analog Comparator's positive input is
// connected to the Bandgap Voltage Reference
// Interrupt on Rising Output Edge
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x4B;
SFIOR=0x00;

// Global enable interrupts
#asm("sei")

t[1]=tmp_m;
if(t[1]>500){t[1]=0;};

t[2]=p_m;
if(t[2]>100){t[2]=0;};

TCCR2=0x05;  // Clock value: 62.500 kHz
TCNT2=0x00;

while (1)
      {
           t_frz=(adc_data*1.1)-437.29;
       //    t_frz=adc_data;
           if(frz==1){t[0]=t[1];}          //    +-5
           else{if(frz_tm_f==1){t[0]=t_frz;frz_tm_f=0;frz_tm_f=0;};};       
                  
                  p=312-(t[2]*3.12); 
                  if(t[2]==101){t[2]=100;}; 
                  if(t[2]==65535){t[2]=0;};
                  
                  if(t[1]==500){t[1]=500;}; 
                  if(t[1]==65535){t[1]=0;};
                  
                  ph=255-(p/256);
                  pl=256-(p-256);
      }
}

interrupt [EXT_INT1] void ext_int1_isr(void)
{
PORTC.1=0;

if(off==0)
{
      if(t_frz<t[1])
      {       
        if(t_frz>(t[1]-5)){frz=1;}
        else{frz=0;};
        
        if(t_frz>=(t[1]-10))
        {
         TCCR1B=0x05;
         TCNT1H=255;
         TCNT1L=216;
        }
         else{PORTC.1=1;}; 
     }
else
     {
       if(t_frz<(t[1]+5)){frz=1;}
       else{frz=0;};
     };
}
else
  {
       if (t[2]==100){PORTC.1=1;}
       else
     {
       if (t[2]!=0)
        {
          TCCR1B=0x04;
          TCNT1H=ph;
          TCNT1L=pl;
       };    
     };
  };               
}
interrupt [EXT_INT0] void ext_int0_isr(void)
{

}

interrupt [TIM2_OVF] void timer2_ovf_isr(void)
{
TCCR2=0x05; // Clock value: 125,000 kHz
TCNT2=230;
  if ((((PIND.4)*2)+PIND.2)!=vcd) 
  { 
     vcd_c++; 
     if(vcd_c==4)
   {
     vcd_c=0;
     if(off==0){vcd_f=1;};
           switch (((PIND.4)*2)+PIND.2)
           {       
            case 0:  if(vcd==1){++t[vcd_f];}
                     else{--t[vcd_f];};         
                     break;
            case 1:  if(vcd==3){++t[vcd_f];}
                     else{--t[vcd_f];};         
                     break; 
            case 2:  if(vcd==0){++t[vcd_f];}
                     else{--t[vcd_f];};         
                     break; 
            case 3:  if(vcd==2){++t[vcd_f];}
                     else{--t[vcd_f];};         
                     break;                             
           };
   };
    vcd_tm=0;               //   
    vcd=((PIND.4)*2)+PIND.2; 
  };  
  
   tm2c++;  
   if(tm2c==5)
   {
   tm2c=0;                
        
          if(adc_data==1023) {off=1;vcd_f=2;}
          else
          {
          if(off==1){off=0;vcd_f=0;vcd_tm=0;};
          if(vcd_f==1){vcd_tm++;if(vcd_tm==1500){vcd_f=0;vcd_tm=0;};};
          };

                    ind[2]=t[vcd_f]/100;
                    ind_tmp=t[vcd_f]-(ind[2]*100);
                    ind[1]=ind_tmp/10;
                    ind[0]=ind_tmp-(ind[1]*10);
     
                    if(ind[2]==0){ind[2]=10;};
                    if(ind[1]==0){if(ind[2]==10){ind[1]=10;};};                 
                      
        
        switch (indcnt)
           {
            case 0:  PORTC.2=0;
                     PORTC.5=1;
                     PORTB=mode[off];
                     indcnt++;
                     break;          
            case 1:  PORTC.5=0;
                     PORTC.4=1;
                     PORTB=dig[ind[0]];
                     indcnt++;
                     break; 
            case 2:  PORTC.4=0;
                     PORTC.3=1;
                     PORTB=dig[ind[1]];      
                     indcnt++;
                     break;
            case 3:  PORTC.3=0;
                     PORTC.2=1;
                     PORTB=dig[ind[2]];
                     indcnt=0;
                     break;   
                 
           };
   }          
} 

interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{ 
          
}

interrupt [TIM1_OVF] void timer1_ovf_isr(void)
{
PORTC.1=1; 
TCCR0=0x00;
TCNT0=0x00;         
}

interrupt [ANA_COMP] void ana_comp_isr(void)
{
if(tmp_m!=t[1]){tmp_m=t[1];};
if(p_m!=t[2]){p_m=t[2];};
}

interrupt [ADC_INT] void adc_isr(void)
{
ADMUX=0xc0 & 0xff;
// Delay needed for the stabilization of the ADC input voltage
if(adc_c==10)
{
adc_c=0;
adc_data=adc_d/10;
adc_d=0;

frz_tm++;
if(frz_tm==255){frz_tm_f=1;frz_tm=0;}   //   
else{frz_tm_f=0;};
};
adc_d=ADCW+adc_d;
adc_c++;
// Start the AD conversion
ADCSRA|=0x40;

}